// TestDrawTextDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDrawText.h"
#include "TestDrawTextDlg.h"
#include "Test.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CTestDrawTextDlg dialog




CTestDrawTextDlg::CTestDrawTextDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDrawTextDlg::IDD, pParent)
	, m_iCount(100)
	, m_iTime(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDrawTextDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_ED_COUNT, m_iCount);
	DDV_MinMaxInt(pDX, m_iCount, 1, 10000);
	DDX_Text(pDX, IDC_ED_RESULT, m_iTime);
	DDX_Control(pDX, IDC_ED_RESULT, m_edTime);
}

BEGIN_MESSAGE_MAP(CTestDrawTextDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
END_MESSAGE_MAP()


// CTestDrawTextDlg message handlers

BOOL CTestDrawTextDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDrawTextDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDrawTextDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDrawTextDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CTestDrawTextDlg::OnOK()
{
	UpdateData();

	// Disable UI and ause AfxPumpMessage to get a smooth UI
	EnableWindow(FALSE);
	// Randomize to same sequence
	srand(0);

	// Ok run the test
	DWORD dwStart = ::GetTickCount();
	for (int i=0; i<m_iCount; ++i)
	{
		// Set count
		SetDlgItemInt(IDC_ED_COUNT,m_iCount-i);

		// In cyles for 100 iteration do some Message Pumping
		MSG msg;
		while (::PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
			AfxPumpMessage();

		// Loop on for 100 time drawtext
		for (int j=0; j<100; ++j)
			TestDrawText(this);
	}
	DWORD dwEnd = ::GetTickCount(),
		  dwLength=dwEnd-dwStart;

	m_iTime = dwLength;
	UpdateData(FALSE);

	// Enable UI 
	EnableWindow(TRUE);
}
